#ifndef ddhUndoableOrthKnife_H
#define ddhUndoableOrthKnife_H

#ifdef _WINDOWS
#define WINDOWS
#endif
#include "ac_plugin.h"
#include "Undoables.h"

//---------------------------------------------------------------------------------------
class DDHUndoableOrthKnife : public Undoable
{

private:

   class CNewVert
   {
   public:
      Vertex *v;
      ACObject *o;
      Vertex *edgev1;
      Vertex *edgev2;
   };

   // The object from which cutting edges are gathered
   ACObject *mKnifeObject;
   // If true, the knife object is deleted
   bool mDeleteKnifeInd;
   // Ortho view against which to slice
   int mView;

   // Whether the Undo was called
   bool mUndoCalled;

   // The deleted knife
   ACObject *mDeletedKnife;
   // The parent of the knife (used in case the knife is deleted)
   ACObject *mDeletedKnifeOwner;

   // List of added vertices
   List *mNewVerts;

   // Test/perform an edge slice
   CNewVert *SliceEdge( ACEdge *edge, ACEdge *knifeedge );

   // Perform the slice
   void DoSlice();

public:

   // Constructor
   DDHUndoableOrthKnife( ACObject *ko, bool delknife, int view );
   // Destructor
   ~DDHUndoableOrthKnife();

   // Add vertices where the knife intersects the selection
   void execute();

   void undo();

   // Return a list of new vertices
   // Free when done
   List *GetNewVerts()
   {
      List *nv = NULL;
      for( List *pv = mNewVerts; pv != NULL; pv = pv->next )
      {
         list_add_item_head( &nv, (( CNewVert * )( pv->data ))->v );
      }
      return nv;
   }

};

#endif
